const Cc = Components.classes;
const Ci = Components.interfaces;

const SENDFROMPC2TV_OPTID_LICENSEDVERSION = 'licensedversion';
const SENDFROMPC2TV_OPTID_CURRENTVERSION = 'currentversion';

const DC_SENDFROMPC2TV_CID        = "{28FD7727-2869-472e-8FC7-A683AF33A841}";


function SendFromPC2TVLicense() {};
SendFromPC2TVLicense.prototype = {
   prefs : Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService).getBranch('extensions.sendfrompc2tv.'),
   observerService : Cc["@mozilla.org/observer-service;1"].getService(Ci.nsIObserverService),
   observer : null,
   elems : {},
   topics : [ "quit-application-granted" ],
   
   // init code
   init: function( evt )
   {
      try {
         this.elems.licenseFrame  = document.getElementById("dcLicenseFrame");

         var observer = {
            observe: function(aSubject, aTopic, aData)
            {
               switch (aTopic) {
               case "quit-application-granted":
                  this.quit();
                  break;
               default:
                  break;
               }
            },
         };

         this.observer = observer;

         for (var topic in this.topics) {
            this.observerService.addObserver( observer, this.topics[topic], false );
         }

         this.document = document;

		 return;
      } catch ( e ) {
		 return;
      }
   },


   // cleanup code
   quit: function( evt )
   {
      try {
         if (this.observerService) {
            for (var topic in this.topics) {
               this.observerService.removeObserver( this.observer, this.topics[topic] );
            }
         }
         this.observerService = null;
         this.elems = null;
         close();
         return;

      } catch ( e ) {
		 return;
      }
   },


   // 'I Accept' button 
   doAgree: function( evt )
   {
      try {
		 var licensedversion = this.prefs.getCharPref(SENDFROMPC2TV_OPTID_CURRENTVERSION);
		 this.prefs.setCharPref(SENDFROMPC2TV_OPTID_LICENSEDVERSION, licensedversion);
         return;

      } catch ( e ) {
         return;
      }
   },


   // 'Cancel' button 
   doCancel: function( evt )
   {
      try {
         var em = Cc["@mozilla.org/extensions/manager;1"].getService(Ci.nsIExtensionManager);
         em.uninstallItem(DC_SENDFROMPC2TV_CID);
         return;
      } catch ( e ) {
		 return;
      }
   }

};


var gSendFromPC2TVLicense = new SendFromPC2TVLicense();
window.addEventListener( "load", gSendFromPC2TVLicense.init, false );
window.addEventListener( "unload", gSendFromPC2TVLicense.quit, false );

