// Global variables
var sendfrompc2tv_httpRequest;
var sendfrompc2tv_httpRequestCallbackFunction;

const SENDFROMPC2TV_LICENSEAGREEMENT_URL  = "chrome://sendfrompc2tv/content/sendfrompc2tvLicense.xul";

const SENDFROMPC2TV_OPTID_LICENSEDVERSION = 'licensedversion';
const SENDFROMPC2TV_OPTID_CURRENTVERSION = 'currentversion';

const SENDFROMPC2TV_EXTENSION_VERSION = "0.7.1 (Beta)";

var sendfrompc2tv = 
{
	// initialization code
	onLoad: function() 
	{
		var aPrefService = Components.classes["@mozilla.org/preferences-service;1"].
								getService(Components.interfaces.nsIPrefService).getBranch('extensions.sendfrompc2tv.'); 
		
		aPrefService.setCharPref(SENDFROMPC2TV_OPTID_CURRENTVERSION, SENDFROMPC2TV_EXTENSION_VERSION);
		
		try 
		{
			var licensedversion = aPrefService.getCharPref(SENDFROMPC2TV_OPTID_LICENSEDVERSION);
		} 
		catch(e) 
		{
			licensedversion = "unknown";
		}
		
		if(licensedversion != SENDFROMPC2TV_EXTENSION_VERSION)
		{
            window.openDialog( SENDFROMPC2TV_LICENSEAGREEMENT_URL, "", "chrome,modal", null);
			// Did the user say "I accept" ?
			try
			{
				licensedversion = aPrefService.getCharPref(SENDFROMPC2TV_OPTID_LICENSEDVERSION);
			}
			catch(e)
			{
				licensedversion = "unknown";
			}
			
			if(licensedversion != SENDFROMPC2TV_EXTENSION_VERSION)
			{
               // license agreement was not accepted, lets go ahead and close browser window, extension will be uninstalled at next startup
               window.close();
               return;
            }
		}
		
		this.initialized = true;
		this.strings = document.getElementById("sendfrompc2tv-strings");
		document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", function(e) { this.showContextMenu(e); }, false);
	},
	
	doOptions: function()
	{
		window.openDialog("chrome://sendfrompc2tv/content/sendfrompc2tvOptions.xul", "sendfrompc2tv-options", "resizable,centerscreen,modal");
	},
	
	showContextMenu: function(event) 
	{
		// show or hide the menuitem based on what the context menu is on
		// see http://kb.mozillazine.org/Adding_items_to_menus
		document.getElementById("context-sendfrompc2tv").hidden = gContextMenu.onImage;
	},
	
	onMenuItemCommandPlayPause: function(e) 
	{
	    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].
								getService(Components.interfaces.nsIPromptService);
		var aPrefService = Components.classes["@mozilla.org/preferences-service;1"].
								getService(Components.interfaces.nsIPrefService).getBranch('extensions.sendfrompc2tv.'); 
        var new_url = null;
            
		try 
		{
			var tvip = aPrefService.getCharPref('tvIpAddress');
		} 
		catch(e) 
		{
			promptService.alert(window, this.strings.getString("SetPrefMsgTitle"),
										this.strings.getString("SetPrefMsg"));
			return;
		}
	 
		try 
		{
			var tvport = aPrefService.getIntPref('tvPortNumber');
		} 
		catch(e) 
		{
			promptService.alert(window, this.strings.getString("SetPrefMsgTitle"),
										this.strings.getString("SetPrefMsg"));
			return;
		}
		
        if(gContextMenu.onLink)
        	new_url = 'http://' + tvip + ':' + tvport + '/renderer.php?method=play&url=' +  encodeURIComponent(gContextMenu.getLinkURL());
        else
            new_url = 'http://' + tvip + ':' + tvport + '/renderer.php?method=pause';
        
		// Send the Play/Pause Command now
		sendfrompc2tv_httpGet(new_url, sendfrompc2tv_processPlayCallback);
    },
	
	onMenuItemCommandPause: function(e) 
	{
	    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].
								getService(Components.interfaces.nsIPromptService);
		var aPrefService = Components.classes["@mozilla.org/preferences-service;1"].
								getService(Components.interfaces.nsIPrefService).getBranch('extensions.sendfrompc2tv.'); 
								
		try 
		{
			var tvip = aPrefService.getCharPref('tvIpAddress');
		} 
		catch(e) 
		{
			promptService.alert(window, this.strings.getString("SetPrefMsgTitle"),
										this.strings.getString("SetPrefMsg"));
			return;
		}
	 
		try 
		{
			var tvport = aPrefService.getIntPref('tvPortNumber');
		} 
		catch(e) 
		{
			promptService.alert(window, this.strings.getString("SetPrefMsgTitle"),
										this.strings.getString("SetPrefMsg"));
			return;
		}
								  
		var new_url = 'http://' + tvip + ':' + tvport + '/renderer.php?method=pause';

		// Send the Play Command now
		sendfrompc2tv_httpGet(new_url, sendfrompc2tv_processPlayCallback);
    },
	
	onMenuItemCommandStop: function(e) 
	{
	    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].
								getService(Components.interfaces.nsIPromptService);
		var aPrefService = Components.classes["@mozilla.org/preferences-service;1"].
								getService(Components.interfaces.nsIPrefService).getBranch('extensions.sendfrompc2tv.'); 
								

		try 
		{
			var tvip = aPrefService.getCharPref('tvIpAddress');
		} 
		catch(e) 
		{
			promptService.alert(window, this.strings.getString("SetPrefMsgTitle"),
										this.strings.getString("SetPrefMsg"));
			return;
		}
	 
		try 
		{
			var tvport = aPrefService.getIntPref('tvPortNumber');
		} 
		catch(e) 
		{
			promptService.alert(window, this.strings.getString("SetPrefMsgTitle"),
										this.strings.getString("SetPrefMsg"));
			return;
		}
								  

		var new_url = 'http://' + tvip + ':' + tvport + '/renderer.php?method=stop';

		// Send the Play Command now
		sendfrompc2tv_httpGet(new_url, sendfrompc2tv_processPlayCallback);
    },
	
	onMenuItemCommandBookmark: function(e) 
	{
	var params = {sendnow:null};
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
    var aPrefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch('extensions.sendfrompc2tv.');
	
	var BMurl = gContextMenu.getLinkURL();
    aPrefService.setCharPref('tvBMurl', BMurl);
	
	var BMtitle = gContextMenu.linkText(); 
    aPrefService.setCharPref('tvBMtitle', BMtitle);
    aPrefService.setCharPref('tvBMdescription',"");

	aPrefService.setBoolPref('tvBMplay', true);
	  
	window.openDialog("chrome://sendfrompc2tv/content/sendfrompc2tvBookmark.xul", "sendfrompc2tv-bookmark", "width=350, height=250, resizable=yes,centerscreen,modal,params", params);
	if (params.sendnow) 
           { 
	       try 
		{
			var tvip = aPrefService.getCharPref('tvIpAddress');
		} 
		catch(e) 
		    {
			
		    promptService.alert(window, this.strings.getString("SetPrefMsgTitle"),
		    							this.strings.getString("SetPrefMsg"));
			return;
		}
	 
		try 
		{
			var tvport = aPrefService.getIntPref('tvPortNumber');
		} 
		catch(e) 
		{
		    
		    promptService.alert(window, this.strings.getString("SetPrefMsgTitle"),
		    							this.strings.getString("SetPrefMsg"));
			return;
		}
		
		try 
		{
			var tvtitle = aPrefService.getCharPref('tvBMtitle');			                                       
		} 
		catch(e) 
		{
		    promptService.alert(window, this.strings.getString("SetPrefMsgTitle"),
		    			this.strings.getString("SetPrefMsg"));		    
			return;
		}

		try 
		{
                                                                  
			var tvdescription = aPrefService.getCharPref('tvBMdescription');
		} 
		catch(e) 
		{
		    promptService.alert(window, this.strings.getString("SetPrefMsgTitle"),
		    							this.strings.getString("SetPrefMsg"));		    
			return;
		}
		try 
		{
			var tvurl = aPrefService.getCharPref('tvBMurl');
		} 
		catch(e) 
		{
		    promptService.alert(window, this.strings.getString("SetPrefMsgTitle"),
		    			this.strings.getString("SetPrefMsg"));
		    alert ("no url"); 
			return;
		}
		
		try 
		{
			var tvplay = aPrefService.getBoolPref('tvBMplay');
		} 
		catch(e) 
		{
		    promptService.alert(window, this.strings.getString("SetPrefMsgTitle"),
		    			this.strings.getString("SetPrefMsg"));
		    alert ("no checkbox"); 
			return;
		}
		
		var new_url = 'http://' + tvip + ':' + tvport + '/system.php?method=addbookmark&title=' + encodeURIComponent(tvtitle) + '&description=' 
		    + encodeURIComponent(tvdescription) + '&icon=&source=' + encodeURIComponent(tvurl); 
      
		sendfrompc2tv_httpGet(new_url, sendfrompc2tv_processPlayCallback);	       
		
		if (tvplay == true)
		{ 
			new_url = 'http://' + tvip + ':' + tvport + '/renderer.php?method=play&url=' +  encodeURIComponent(tvurl);
			sendfrompc2tv_httpGet(new_url, sendfrompc2tv_processPlayCallback);	 		
		} 
	       
	   }
	   else
	   { 	  
	       // user pressed canceled or close or his firefox crashed
	   } 
	}, 


};

window.addEventListener("load", function(e) { sendfrompc2tv.onLoad(e); }, false);


// event callbacks

function sendfrompc2tv_processPlayCallback () 
{
// Do Nothing

//    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].
//							getService(Components.interfaces.nsIPromptService);

//    promptService.alert(window,this.strings.getString("helloMessageTitle"),
//                                sendfrompc2tv_httpRequest.getAllResponseHeaders());
				
}

function sendfrompc2tv_httpExecuteCallback() 
{
	if (sendfrompc2tv_httpRequestCallbackFunction != null) 
	{
		if (sendfrompc2tv_httpRequest.readyState == 4) 
		{
			if (sendfrompc2tv_httpRequest.status == 200) 
			{
				sendfrompc2tv_httpRequestCallbackFunction();
				sendfrompc2tv_httpRequestCallbackFunction = null;
			}
		}
	}
}

function sendfrompc2tv_httpGet(url, callbackFunction) 
{
	sendfrompc2tv_httpRequest = false;
	sendfrompc2tv_httpRequestCallbackFunction = callbackFunction;
	sendfrompc2tv_httpRequest = new XMLHttpRequest();
	sendfrompc2tv_httpRequest.onreadystatechange = sendfrompc2tv_httpExecuteCallback;
    sendfrompc2tv_httpRequest.open('GET', url, true);
    sendfrompc2tv_httpRequest.send(null);
}
